package de.accso.flexinale.api_in.web;

import de.accso.flexinale.application.services.TicketService;
import de.accso.flexinale.application.services.VorfuehrungService;
import de.accso.flexinale.domain.model.KontingentBereitsAusgeschoepftException;
import de.accso.flexinale.domain.model.Besucher;
import de.accso.flexinale.domain.model.Film;
import de.accso.flexinale.domain.model.KinoSaal;
import de.accso.flexinale.domain.model.Ticket;
import de.accso.flexinale.domain.model.Vorfuehrung;
import de.accso.flexinale.infrastructure.security.BenutzerDetailsService;
import de.accso.flexinale.shared_kernel.Identifiable;
import de.accso.flexinale.shared_kernel.RawWrapper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.mvc.support.RedirectAttributes;

import java.time.LocalDateTime;
import java.util.List;

@Controller
public class TicketWebController {

    private static final Logger LOGGER = LoggerFactory.getLogger(TicketWebController.class);

    @Autowired
    private TicketService ticketService;

    @Autowired
    private BenutzerDetailsService benutzerService;

    @Autowired
    private VorfuehrungService vorfuehrungService;

    @GetMapping(value="/tickets")
    @PreAuthorize("hasRole('ROLE_BESUCHER')")
    public String listTickets(final Model model) {
        Besucher loggedInBenutzer = benutzerService.getLoggedInBesucher();

        List<Ticket> allTickets = ticketService.findByBesucherOrderByZeit(loggedInBenutzer);
        List<List<VorfuehrungMitAnzahlTicketsTO>> ticketsByDay = TicketSorter.sortAndMapTicketsPerDay(allTickets);

        model.addAttribute("ticketsByDay", ticketsByDay);

        int totalNumberOfTickets = ticketService.gesamtZahlDerTicketsFuer(loggedInBenutzer);
        model.addAttribute("totalNumberOfTickets", totalNumberOfTickets);

        return ("tickets");
    }

    @PostMapping("/vorfuehrung/loeseGutscheineOnlineEin")
    @PreAuthorize("hasRole('ROLE_BESUCHER')")
    public String loeseGutscheineOnlineEin(
                       @RequestParam("vorfuehrungId") final String vId,
                       @RequestParam("anzahl")        final int anzahl,
                       final RedirectAttributes redirAttrs) {
        Besucher loggedInBesucher = benutzerService.getLoggedInBesucher();

        Identifiable.Id vorfuehrungId = Identifiable.Id.of(vId);
        try {
            ticketService.loeseGutscheineOnlineFuerVorfuehrungEin(vorfuehrungId, loggedInBesucher, anzahl);
        }
        catch (KontingentBereitsAusgeschoepftException kbaEx) {
            String message = "Kontingent exceeded: no %d tickets for Vorfuehrung %s and Besucher %s available"
                    .formatted(anzahl, vorfuehrungId, loggedInBesucher.login);
            LOGGER.info(message);

            Vorfuehrung vorfuehrung = vorfuehrungService.vorfuehrung(vorfuehrungId);
            String filmId = vorfuehrung.film.id().id();

            redirAttrs.addFlashAttribute("error", "Keine %d Tickets mehr vorhanden".formatted(anzahl));
            return "redirect:/film/" + filmId;
        }
        redirAttrs.addFlashAttribute("success", "%d Ticket(s) erfolgreich gekauft".formatted(anzahl));
        return "redirect:/tickets";
    }
}

// class used to "flatten" Vorfuehrung and number of Tickets for Vorfuehrung for Clients
record VorfuehrungMitAnzahlTicketsTO(Zeit zeit, Film film, KinoSaal kinoSaal, AnzahlTickets anzahlTickets) {
    public record Zeit(LocalDateTime raw) implements RawWrapper<LocalDateTime> {
        public Zeit(LocalDateTime raw) {
            this.raw = raw.withNano(0); // precision is second
        }
    }

    public record AnzahlTickets(Integer raw) implements RawWrapper<Integer> {}
}